package anywharesoftware.b4a.sample;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

import android.os.SystemClock;

import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.View;
import android.view.KeyEvent;
import android.widget.TextView;
import android.widget.Toast;
import android.util.Log;
import android.view.MotionEvent;

import com.google.android.glass.app.Card;
import com.google.android.glass.media.Sounds;
import com.google.android.glass.touchpad.Gesture;
import com.google.android.glass.touchpad.GestureDetector;


  @Version(1.22f)
  @Author("Alberto Iglesias - alberto@visualnet.inf.br")
//@Permissions(values={"android.permission.INTERNET"})
  @ShortName("GlassLib")
  @DependsOn(values = { "gdk" })
  @ActivityObject


public class FirstLib {

		private String eventName;
		private GestureDetector mGestureDetector;


	public void Initialize(final BA ba, final String EventName)
	{
		final String eventName = EventName.toLowerCase(BA.cul);


          mGestureDetector = createGestureDetector(ba);

	}


	static void GravaLog(String logMe)
	{
	    android.util.Log.v("teste", SystemClock.uptimeMillis() + " " + logMe);
	}

	public int TesteAdd(int x, int y)
	{
		return x + y;
	}

	public void Toast(BA ba, String pTexto)
	{
		Toast.makeText(ba.context, pTexto, Toast.LENGTH_SHORT).show();
	}

    private GestureDetector createGestureDetector(final BA ba)
    {

        Log.d("B4A", "createGestureDetector");

		Toast.makeText(ba.context, "createGestureDetector", Toast.LENGTH_SHORT).show();

        GestureDetector gestureDetector = new GestureDetector(ba.context);

        //Create a base listener for generic gestures
        gestureDetector.setBaseListener( new GestureDetector.BaseListener() {
            @Override
            public boolean onGesture(Gesture gesture)
            {

  			    Log.d("B4A", "onGesture");
                ba.raiseEvent(this, eventName + "_onGesture", gesture);


                switch (gesture) {
                    case TAP:
                        //Toast.makeText( ba.context, "TAP", Toast.LENGTH_SHORT).show();
                        break;
                    case LONG_PRESS:
                        //Toast.makeText( ba.context, "LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_DOWN:
                        //Toast.makeText( ba.context, "SWIPE_DOWN called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_LEFT:
                        //Toast.makeText( ba.context, "SWIPE_LEFT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_RIGHT:
                        //Toast.makeText( ba.context, "SWIPE_RIGHT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_UP:
                        //Toast.makeText( ba.context, "SWIPE_UP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case THREE_LONG_PRESS:
                        //Toast.makeText( ba.context, "THREE_LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case THREE_TAP:
                        //Toast.makeText( ba.context, "THREE_TAP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_LONG_PRESS:
                        //Toast.makeText( ba.context, "TWO_LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_DOWN:
                        //Toast.makeText( ba.context, "TWO_SWIPE_DOWN called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_LEFT:
                        //Toast.makeText( ba.context, "TWO_SWIPE_LEFT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_RIGHT:
                        //Toast.makeText( ba.context, "TWO_SWIPE_RIGHT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_UP:
                        //Toast.makeText( ba.context, "TWO_SWIPE_UP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_TAP:
                        //Toast.makeText( ba.context, "TWO_TAP called.", Toast.LENGTH_SHORT).show();
                        return true;
                }

                return false;
            }
        });
        gestureDetector.setFingerListener(new com.google.android.glass.touchpad.GestureDetector.FingerListener() {
            @Override
            public void onFingerCountChanged(int previousCount, int currentCount) {
                // do something on finger count changes
                //Log.e(TAG,"onFingerCountChanged()");


            }
        });
        gestureDetector.setScrollListener(new com.google.android.glass.touchpad.GestureDetector.ScrollListener() {
            @Override
            public boolean onScroll(float displacement, float delta, float velocity) {
                // do something on scrolling
                //Log.e(TAG,"onScroll()");
                return false;
            }
        });
        return gestureDetector;
    }

	    public boolean onGenericMotionEvent(MotionEvent event) {
	        if (mGestureDetector != null) {
	            return mGestureDetector.onMotionEvent(event);
	        }
	        return false;
    }

}



